#!/usr/bin/env python

# nerv -- Nessus Report Viever
#
# au: vitas@matfyz.cz
# cp: gpl

#report muze byt:
# 
# ser
# 0 note
# 1 warning
# 2 hole


### edit this
nerv_lib_dir = "/home/vitas/vs/nerv/"
nessus_plugins_dir = "/usr/lib/nessus/plugins/"

SEC_note    = 0
SEC_war	    = 1
SEC_hole    = 2

# check:
# 0 checked
# 1 checked negative
# 2 checked positive
# 3 unchecked

# ?!+-

CH_unchecked = 3
CH_again =    2
CH_positive = 1
CH_negative = 0
CH_cheked = -1



import pprint
import re

import sys
import os
import shutil
import gtk
import gtk.gdk
import gobject
import string
import time

file_name = ''

book_closed_xpm = [
    "16 16 6 1",
    "       c None s None",
    ".      c black",
    "X      c red",
    "o      c yellow",
    "O      c #808080",
    "#      c white",
    "                ",
    "       ..       ",
    "     ..XX.      ",
    "   ..XXXXX.     ",
    " ..XXXXXXXX.    ",
    ".ooXXXXXXXXX.   ",
    "..ooXXXXXXXXX.  ",
    ".X.ooXXXXXXXXX. ",
    ".XX.ooXXXXXX..  ",
    " .XX.ooXXX..#O  ",
    "  .XX.oo..##OO. ",
    "   .XX..##OO..  ",
    "    .X.#OO..    ",
    "     ..O..      ",
    "      ..        ",
    "                "]


# dirty python hack to have class-method:
class Callable:
    def __init__(self, anycallable):
            self.__call__ = anycallable

class Rep_base:
    def add_to_store(self, model):
	iter = model.append(None)
	self.update_in_store(model, iter)
	return iter

    def update_in_store(self, model, iter):
	self.error()

    def sort(mapping):
	vals = list(mapping.values());
	vals.sort(
	    lambda a,b:
		cmp(a.sort_key,b.sort_key));
	return vals
    sort = Callable(sort);

# vraci True : jestli byl zmenen
    def update_check(self, newcheck):

	if self.check == newcheck:
	    return False;
	    
	if self.check <= newcheck:
	    self.check = newcheck;
	    return True

	return self.compute_check()

    def compute_security(self):
	max = 0;
	for v in self.sons.values():
	    if v.security > max:
		max = v.security
	self.security = max

    def compute_check(self):
	oldcheck = self.check
	max = 0;
	for v in self.sons.values():
	    if v.check > max:
		max = v.check
	self.check = max
	return oldcheck != self.check

    def security_pic(self):

	if(self.security == SEC_note): return pixbuf["info_small"]
	if(self.security == SEC_war): return pixbuf["warning_small"]
	if(self.security == SEC_hole): return pixbuf["error_small"]
	print "warning unknown security:", self.security
	return pixbuf["user"]

    def check_pic(self):

	if(self.check == CH_positive): return pixbuf["white"]
	if(self.check == CH_negative): return pixbuf["yellow"]
	if(self.check == CH_again): return pixbuf["bang"]
	if(self.check == CH_unchecked): return pixbuf["red"]

#	if(self.check == CH_positive): return pixbuf["plus"]
#	if(self.check == CH_negative): return pixbuf["minus"]
#	if(self.check == CH_again): return pixbuf["bang"]
#	if(self.check == CH_unchecked): return pixbuf["question"]
	return pixbuf["user"]

    def problem_pic(self):

	if(self.problem): return pixbuf["user"]
	return None;
    

class Rep_host(Rep_base):


    def __init__(self, name=None):

	self.dns = name
	self.ip = name
	self.short = "X"
	self.group = "A"
	self.ends = []
	
	# is  'name' as IP ?
	for c in name:
	    if not c in ".0123456789":
		#no
		self.sort_key = name
		break
	else:
	    # yes sort
	    self.sort_key =  \
		string.join( ["%02x"%int(x) for x in name.split('.') ], '' )



	self.ports = {}
	self.sons = self.ports
	self.check = 0
	self.security = 0
	self.problem = False
	self.group = 'C'


    COL_self	= 0
    COL_dns	= 1
    COL_ip	= 2
    COL_short	= 3
    COL_sort_key= 4
    COL_group	= 5
    COL_problem	= 6
    COL_security= 7
    COL_check	= 8

    def update_in_store(self, model, iter):

	model.set_value(iter, Rep_host.COL_self,	self)
	model.set_value(iter, Rep_host.COL_dns,		self.dns)
	model.set_value(iter, Rep_host.COL_ip,		self.ip)
	model.set_value(iter, Rep_host.COL_short,	self.short)
	model.set_value(iter, Rep_host.COL_sort_key,	self.sort_key)
	model.set_value(iter, Rep_host.COL_group,	self.group)
	model.set_value(iter, Rep_host.COL_security,    self.problem_pic())
	model.set_value(iter, Rep_host.COL_security,    self.security_pic())
	model.set_value(iter, Rep_host.COL_check,	self.check_pic())

    def create_tree():

	model = gtk.ListStore(
			    gobject.TYPE_PYOBJECT,  # 0
			    gobject.TYPE_STRING,    # 1
			    gobject.TYPE_STRING,    # 2
			    gobject.TYPE_STRING,    # 3
			    gobject.TYPE_STRING,    # 4
			    gobject.TYPE_STRING,    # 5
			    gtk.gdk.Pixbuf,	    # 6
			    gtk.gdk.Pixbuf,	    # 7
			    gtk.gdk.Pixbuf)	    # 8
	model.set_sort_func(3, Rep_host.cmp, "ahoj")
	model.set_sort_column_id(3, gtk.SORT_ASCENDING)

	tree = gtk.TreeView(model);

	tree.append_column(gtk.TreeViewColumn(
	    "P",
	    gtk.CellRendererPixbuf(),
	    pixbuf=Rep_host.COL_problem));


	tree.append_column(gtk.TreeViewColumn(
	    "CH",
	    gtk.CellRendererPixbuf(),
	    pixbuf=Rep_host.COL_check));


	tree.append_column(gtk.TreeViewColumn(
	    "S",
	    gtk.CellRendererPixbuf(),
	    pixbuf=Rep_host.COL_security));

	ren = gtk.CellRendererText()
	ren.set_property("editable", gtk.TRUE)
	tree.group_renderer = ren;
	tree.append_column(gtk.TreeViewColumn(
	    "G",
	    ren, 
	    text=Rep_host.COL_group));

	ren = gtk.CellRendererText()
	ren.set_property("editable", gtk.TRUE)
	tree.short_renderer = ren;
	tree.append_column(gtk.TreeViewColumn(
	    "Short",
	    ren,
	    text=Rep_host.COL_short));


	tree.append_column(gtk.TreeViewColumn(
	    "IP",
	    gtk.CellRendererText(),
	    text=Rep_host.COL_ip));

	ren = gtk.CellRendererText()
	tree.dns_renderer = ren;
	ren.set_property("editable", gtk.TRUE)
	tree.append_column(gtk.TreeViewColumn(
	    "DNS",
	    ren,
	    text=Rep_host.COL_dns));

	return tree;
    create_tree = Callable(create_tree);

    def add_end(self, end, date):

	datep = time.strptime(date)

	if len(self.ends) == 0:
	    self.ends.append( { end: datep} )
	    return

	if self.ends[-1].has_key(end):
	    self.ends.append( { end: datep } )
	    return

	self.ends[-1][end] = datep 


    def cmp(treemodel, iter1, iter2, user_data):
	#print "host cmp"

	a = treemodel[iter1][Rep_host.COL_group]
	b = treemodel[iter2][Rep_host.COL_group]
	if( a != b ): return cmp(a,b)

	a = treemodel[iter1][Rep_host.COL_sort_key]
	b = treemodel[iter2][Rep_host.COL_sort_key]
	return cmp(a,b)

    cmp = Callable(cmp);

class Rep_port(Rep_base):



    def __init__(self, id, svc_name, portnum, proto = 'tcp'):

	
	self.svc_name = svc_name

	self.udp = ( proto == 'udp' )
	self.portnum = int(portnum)
	self.group = [ id ]

	self.sort_key = self.portnum * 10

	self.name = id
	self.id = id

	if id == "general/tcp":

	    self.name = "gen/tcp"
	    self.sort_key = 1

	elif id == "general/udp":

	    self.name = "gen/udp"
	    self.sort_key = 2

	elif id == "general/icmp":

	    self.name = "gen/icmp"
	    self.sort_key = 3

	self.my_name = self.name

	if self.udp :
	    self.portshort = portnum + "u"
	    self.sort_key += 1
	else: 
	    self.portshort = portnum

	self.proto =  proto 

	self.reps = {}
	self.sons = self.reps

	self.security = 0
	self.check = 0

    COL_self	= 0
    COL_name	= 1
    COL_portnum = 2
    COL_proto	= 3
    COL_svc_name= 4
    COL_udp	= 5
    COL_security= 6
    COL_check	= 7

    def update_in_store(self, model, iter):
	model.set_value(iter, Rep_port.COL_self,	self)
	model.set_value(iter, Rep_port.COL_name,	self.name)
	model.set_value(iter, Rep_port.COL_portnum,	self.portnum)
	model.set_value(iter, Rep_port.COL_svc_name,	self.svc_name)
	model.set_value(iter, Rep_port.COL_proto,	self.proto)
	model.set_value(iter, Rep_port.COL_udp,		self.udp)
	model.set_value(iter, Rep_port.COL_security,	self.security_pic())
	model.set_value(iter, Rep_port.COL_check,	self.check_pic())
	model.sort_column_changed()
	#print"kuk"
    

    def create_tree():

	#print"kuk2"
	model = gtk.ListStore(
		    gobject.TYPE_PYOBJECT,  # 0
		    gobject.TYPE_STRING,    # 1
		    gobject.TYPE_INT,	    # 2
		    gobject.TYPE_STRING,    # 3
		    gobject.TYPE_STRING,    # 4
		    gobject.TYPE_BOOLEAN,   # 5
		    gtk.gdk.Pixbuf,	    # 6
		    gtk.gdk.Pixbuf)	    # 7

	model.set_sort_func(2, Rep_port.cmp, "ahoj")
	model.set_sort_column_id(2, gtk.SORT_ASCENDING)

	#print "create_treee:", model.get_sort_column_id()

	if( model.has_default_sort_func() ) :
	    print "mam sort fci"
		    
	tree =  gtk.TreeView(model)
	tree.set_enable_search(gtk.TRUE)
	tree.set_search_column(1)

	ren = gtk.CellRendererPixbuf()
	ren.set_property("yalign", 0)
	tree.append_column(gtk.TreeViewColumn(
	    "CH",
	    ren, 
	    pixbuf=Rep_port.COL_check));

	ren = gtk.CellRendererPixbuf()
	ren.set_property("yalign", 0)
	tree.append_column(gtk.TreeViewColumn(
	    "S",
	    ren,
	    pixbuf=Rep_port.COL_security));


	#tree.append_column(gtk.TreeViewColumn(
	#    "Num",
	#    gtk.CellRendererText(),
	#    text=Rep_port.COL_security));

	tree.append_column(gtk.TreeViewColumn(
	    "Port",
	    gtk.CellRendererText(),
	    text=Rep_port.COL_name));

	tree.svc_renderer = gtk.CellRendererText()
	tree.svc_renderer.set_property("yalign", 0)
	tree.svc_renderer.set_property("editable", True)
	tree.append_column(gtk.TreeViewColumn(
	    "Service",
	    tree.svc_renderer,
	    text=Rep_port.COL_svc_name));

	return tree

    create_tree = Callable(create_tree);

    def cmp(treemodel, iter1, iter2, user_data):
	#print "cmp:", iter1, iter2
	#print "proto1:", treemodel[iter1][Rep_port.COL_portnum]
	#print "proto2:", treemodel[iter2][Rep_port.COL_portnum]
	return cmp(
	    treemodel[iter1][Rep_port.COL_portnum],
	    treemodel[iter2][Rep_port.COL_portnum])

    cmp = Callable(cmp);

    # return:  id, name, port, proto
    def to_portname(nbe_name):

	reg = Rep_port.port_re.search(nbe_name)

	if( reg == None ):
	    return  [nbe_name, "??", "0", "??" ]
	
	#print nbe_name, reg
	sername, portnum, proto = reg.groups()

	portid = portnum + "/" + proto

	#name = portid + "(" + portname + ")"

	return   [ portid, sername, portnum, proto ]

    to_portname = Callable(to_portname)
	

    port_re = re.compile("^([^\(]+)\s+\((\d+)/(\S+)\)$")

class Rep_rep(Rep_base):

    def __init__(self, port_id, port_num, rep_id, script, security, txt):
	#self.par = par
	self.port_id = port_id
	self.port_num = port_num
	self.rep_id = rep_id
	#self.name = rep_id
	self.name = script
	self.note = ""
	self.cves = ""
	self.script = None
	self.sort_key = rep_id

	if( script in script_nums):
	    self.name = script_nums[script] 
	    self.script = script_nums[script]
	

	self.txtorig = txt
	self.txt = re.sub('\\\\n', "\n", txt)
	self.extract_cves()

	self.check = CH_unchecked
	self.security = security
	self.security = {
		'N': 0,
		'W': 1,
		'H': 2 }.get(security, -1)

	if self.security < 0 : 
	    print "unknown security:", security

    def add_note(self, txt):

	txt = re.sub('\\\\n', "\n", txt)
	self.txt += "\n--------------\n" + txt
	self.extract_cves()

    re_cve = re.compile('^CVE : (.*)$', re.M)
    re_bid = re.compile('^BID : (.*)$', re.M)

    def extract_cves(self):
	self.cves = "cve"
	self.cves = ''

	bag = []

	for row in self.re_cve.finditer(self.txt):
	    bag[len(bag):] = row.group(1).strip().split(', ')

	for row in self.re_bid.finditer(self.txt):
	    bids = row.group(1).strip().split(" ")
	    bag[len(bag):] = [ "BID-" + b for b in bids ]

	self.cves = ', '.join(bag)
	

    # pri ukladani ulozime nejdrive ty bez poznamek
    def sort_save_fc(a, b):

	if a.note ==  b.note == '' :
	    return cmp(a.sort_key, b.sort_key);

	if a.note == '':
	    return -1

	if b.note == '':
	    return 1
	    
	return cmp(a.sort_key, b.sort_key);


    sort_save_fc = Callable(sort_save_fc);

    def sort_save(mapping):
	vals = list(mapping.values())
	vals.sort( Rep_rep.sort_save_fc)
	return vals
    sort_save = Callable(sort_save);


    def set_security(self, sec):
	if( self.check != check) :
	    self.security = sec
	    self.par.update_security(security)
	
    def set_check(self, check):
	if( self.check != check):
	    self.check = check
	    self.par.update_check(check)

    def set_check_as_char(self, check):

	self.check = {	"+": CH_positive, 
			"-": CH_negative,
			"!": CH_again,
			"?": CH_unchecked}.get(check, "CH_unchecked");
	

    def get_check_as_char(self):

	return { CH_positive: "+", 
		 CH_negative: "-",
		 CH_again:    "!",
		 CH_unchecked: "?"}.get(self.check, "X");


    COL_self	= 0
    COL_name	= 1
    COL_security= 2
    COL_check	= 3

    def set_check_next(self):
	self.check = {
		CH_unchecked:	CH_positive,
		CH_positive:	CH_negative,
		CH_negative:	CH_again,
		CH_again:	CH_unchecked,
		}[self.check]

    def update_in_store(self, model, iter):
	model.set_value(iter, Rep_rep.COL_self,		self)
	model.set_value(iter, Rep_rep.COL_name,		self.name)
	model.set_value(iter, Rep_rep.COL_security,	self.security_pic())
	model.set_value(iter, Rep_rep.COL_check,	self.check_pic())

    def create_tree():

	model = gtk.ListStore(
		    gobject.TYPE_PYOBJECT,  # 0
		    gobject.TYPE_STRING,    # 1
		    gtk.gdk.Pixbuf,	    # 2
		    gtk.gdk.Pixbuf)	    # 3

	model.set_sort_func(2, Rep_rep.cmp, "ahoj")
	model.set_sort_column_id(2, gtk.SORT_DESCENDING)


	tree =  gtk.TreeView(model);
	tree.set_headers_clickable(gtk.TRUE)

	tree.check_renderer = gtk.CellRendererPixbuf()
	tree.append_column(gtk.TreeViewColumn(
	    "CH",
	    tree.check_renderer,
	    pixbuf=Rep_rep.COL_check));

	tree.append_column(gtk.TreeViewColumn(
	    "S",
	    gtk.CellRendererPixbuf(),
	    pixbuf=Rep_rep.COL_security));

	tree.append_column(gtk.TreeViewColumn(
	    "Rep",
	    gtk.CellRendererText(),
	    text=Rep_rep.COL_name));

	return tree;
    create_tree = Callable(create_tree);

    def check_toggle(self):
	    print "check toggle"
    check_toggle= Callable(check_toggle)

    def cmp(treemodel, iter1, iter2, user_data):
	
	a = treemodel[iter1][Rep_port.COL_self]
	b = treemodel[iter2][Rep_port.COL_self]

	if( a.security != b.security ):
	    return cmp(a.security, b.security)

	#if( a.check != b.check ):
	#    return cmp(a.check, b.check)

	return cmp( a.name, b.name)
    cmp = Callable(cmp)


class Nessus_view:
    # Our callback.
    # The data passed to this method is printed to stdout

    def __init__(self):

	self.init_pix()

	self.not_help = True

	self.cb_forbiden = False

	#pp = pprint.PrettyPrinter(indent=4)

	self.report = {}
	self.cur_rep = None

	self.load_script_nums()
	self.parse(file_name)
	self.report_text =  Repp("pok.rep", self)
	self.compute_security_and_check()

        # Create a new window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
	self.window.set_icon( pixbuf['mozek_small'] )

        # Set the window title
        self.window.set_title("Nerving " + file_name)
	vbox = gtk.VBox()

        # Set a handler for delete_event that immediately
        # exits GTK.
        self.window.connect("delete_event", self.delete_event)

        # Sets the border width of the window.
        self.window.set_border_width(2)

        # Put the table in the main window
        self.window.add(vbox)
	vbox.show()

	# hbox
	#hbox = gtk.HBox();
	#hbox.set_spacing(3);
	#hbox.set_homogeneous(gtk.FALSE)

	hpaned1 = gtk.HPaned()
	hpaned2 = gtk.HPaned()
	hpaned3 = gtk.HPaned()


	self.hpaned1=hpaned1
	self.hpaned2=hpaned2
	self.hpaned3=hpaned3

        # Create list view of host port report
	host_view = self.create_host_view()
	port_view = self.create_port_view()
	rep_view  = self.create_rep_view()

	#hbox.pack_start(host_view)
	#hbox.pack_start(port_view)
	#hbox.pack_start(rep_view)

	hpaned2.pack1(port_view, gtk.TRUE)
	hpaned2.pack2(rep_view, gtk.TRUE)

	hpaned1.pack1(host_view, gtk.TRUE)
	hpaned1.pack2(hpaned2, gtk.TRUE)


	host_view.show()
	port_view.show()
	rep_view.show()


	hpaned2.show()
	hpaned1.show()

	hpaned1.set_position(70)
	hpaned2.set_position(40)

        #hbox.show()

	# Midle text window
	text_buf = gtk.TextBuffer()
	text_buf.set_text("<none>")
	text = gtk.TextView(text_buf)
	text.set_wrap_mode(gtk.WRAP_CHAR)
	#print text.get_default_attributes().get_attribute("font")
	#text.set_property("font", "fixed")
	#text.set_editable(gtk.FALSE)
	#text.set_wrap_mode(gtk.WRAP_WORD)
	self.text = text

	scro = gtk.ScrolledWindow()
	scro.add(text)
	text.show()

	scro.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)


	mods_vbox = gtk.VBox()

	mods_vbox = gtk.VBox()

	modules = [
	    Module_netmap,
	    Module_general,
	    Module_rpc,
	    Module_hosts,
	    Module_kuk,
	    Module_runtimes,
	    ]

	for mod in modules : 
	    m =  mod(self).create_widget()
	    mods_vbox.pack_start(m, False, False)
	    m.show()


	scro2 = gtk.ScrolledWindow()
	scro2.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	scro2.add_with_viewport(mods_vbox)
	mods_vbox.show()

	hpaned3.set_position(0)
	hpaned3.pack2(scro, True)
	hpaned3.pack1(scro2, False)

	scro2.show()
	scro.show()


	hpaned3.show();

	# norm
	tag = gtk.TextTag('norm')
	tag.set_property('family',"Monospace")
	text.get_buffer().get_tag_table().add(tag)

	# can or cve
	tag = gtk.TextTag('cancve')
	tag.set_property('foreground',"red")
	tag.set_property('underline',True)

	text.get_buffer().get_tag_table().add(tag)
	tag.connect("event", self.tag_cancve_callback)

	#bid
	tag = gtk.TextTag('bid')

	tag.set_property('foreground',"green")
	tag.set_property('underline',True)

	text.get_buffer().get_tag_table().add(tag)
	tag.connect("event", self.tag_bid_callback)

	# url
	tag = gtk.TextTag('url')
	tag.set_property('foreground',"blue")
	tag.set_property('underline',True)

	tag.connect("event", self.tag_url_callback)
	text.get_buffer().get_tag_table().add(tag)

	# pozn
	tag = gtk.TextTag('pozn')
	tag.set_property('background',"yellow")
	tag.set_property('editable',True)
	text.get_buffer().get_tag_table().add(tag)


	# head
	tag = gtk.TextTag('head')
	tag.set_property('foreground',"blue")
	text.get_buffer().get_tag_table().add(tag)
	#tag.set_property('editable',True)


	#self.window.connect("key-press-event", self.window_key_callback)
	#hbox.connect("key-press-event", self.window_key_callback)
	hpaned1.connect("key-press-event", self.window_key_callback)
	self.window.connect("key-press-event", self.esc_key_callback)

	self.text = text;

	# Bottom buttons
	hbox2 = gtk.HBox();
	hbox2.connect("key-press-event", self.window_key_callback)

	self.buttonQ = gtk.Button(":q!")
	self.buttonS = gtk.Button(":w")
        self.buttonV = gtk.Button("view")
        self.buttonG = gtk.Button("G")
        self.buttonM = gtk.Button(">")
        self.buttonH = gtk.Button("?")
        self.buttonT = gtk.Button("~")
        #self.status = gtk.Label("Press ? for help.")
        #self.status = gtk.TextView()
        self.status = gtk.Entry()
	#self.status.set_alignment(0,0.5)
	self.status_line("Press ? for help.")

        self.buttonQ.connect("clicked", gtk.mainquit)
        self.buttonS.connect("clicked", self.save_changes)
        self.buttonV.connect("clicked", self.view_script)
        self.buttonT.connect("clicked", self.change_check)
        self.buttonG.connect("clicked", self.group_ports)
        self.buttonH.connect("clicked", self.toggle_help)
        self.buttonM.connect("clicked", self.toggle_modules)

        hpaned3.connect("notify", self.modbar_callback)

	hbox2.pack_start(self.buttonM,False, False)
	hbox2.pack_start(self.status)
	hbox2.pack_start(self.buttonV,False, False)
	hbox2.pack_start(self.buttonG,False, False)
	hbox2.pack_start(self.buttonT,False, False)
	hbox2.pack_start(self.buttonH,False, False)
	hbox2.pack_start(self.buttonS,False, False)
	hbox2.pack_start(self.buttonQ,False, False)

	self.buttonQ.show()
	self.buttonS.show()
	self.buttonM.show()
	self.buttonH.show()
	self.buttonT.show()
	self.buttonG.show()
	self.buttonV.show()
	self.status.show()

	# pack it together
	paned = gtk.VPaned();

	#paned.pack1(hbox, gtk.TRUE);
	paned.pack1(hpaned1, gtk.TRUE);
	paned.pack2(hpaned3, gtk.TRUE);

	vbox.pack_start(paned);

	#vbox.pack_start(text);
	vbox.pack_start(hbox2, gtk.FALSE);
	paned.show()
	paned.set_position(40)
	#vbox.set_homogeneous(gtk.FALSE)

	#hbox.show()
	scro.show()
	hbox2.show()

	self.update_host_store()
        self.window.show()
	self.window.resize(800, 700)


    def status_line(self, txt):
	#self.status.set_text(txt)
	#self.status.get_buffer().set_text(txt)
	self.status.set_text(txt)


    def save_changes(self, widget=None):
	#self.report_text.save_file("ahoj.rep");
	self.save_cur_rep_note()
	self.report_text.save_template("nerv.rep");
	self.status_line("Saved as 'nerv.rep'");
	
    def next_rep(self):

	model = self.rep_view.get_model()
	path0 =  self.rep_view.get_cursor()[0][0]

	path0 += 1

	if( path0 >= len(model) ):
	    self.next_port()
	    return

	self.rep_view.set_cursor((path0,), None)

    def prev_rep(self):
	model = self.rep_view.get_model()
	path0 =  self.rep_view.get_cursor()[0][0]


	path0 -= 1

	if( path0 < 0 ):
	    self.prev_port()
	    return

	self.rep_view.set_cursor((path0,), None)
	
    def prev_port(self):
	model = self.port_view.get_model()
	path0 =  self.port_view.get_cursor()[0][0]

	path0 -= 1

	if( path0 < 0 ):
	    self.prev_host()
	    return

	self.port_view.set_cursor((path0,), None)
	self.rep_view.set_cursor((len(self.rep_view.get_model())-1,), None)

    def get_hosts(self):
	return self.report

    def next_port(self):
	model = self.port_view.get_model()
	path0 =  self.port_view.get_cursor()[0][0]

	path0 += 1

	if( path0 >= len(model) ):
	    self.next_host()
	    return

	self.port_view.set_cursor((path0,), None)

    def next_host(self):

	model = self.host_view.get_model()
	path0 =  self.host_view.get_cursor()[0][0]

	path0 += 1

	if( path0 >= len(model) ):
	    return

	self.host_view.set_cursor((path0,), None)

    def prev_host(self):

	model = self.host_view.get_model()
	path0 =  self.host_view.get_cursor()[0][0]

	path0 -= 1

	if( path0 < 0  ):
	    return

	self.host_view.set_cursor((path0,), None)
	self.port_view.set_cursor((len(self.port_view.get_model())-1,), None)

    def prev_problem(self):

	rep_id = self.cur_rep.rep_id
	port_id = self.cur_rep.port_id

	model = self.host_view.get_model()
	path0 = self.host_view.get_cursor()[0][0]

	path0 -= 1
	while( path0 >= 0  ):

	    if( model[path0][Rep_host.COL_problem] != None):

		self.host_view.set_cursor((path0,))
		self.update_port_store(port_id)
		self.update_rep_store(rep_id)
		self.update_text()
		return
	    path0 -= 1

	#nic
    def next_problem(self):

	rep_id = self.cur_rep.rep_id
	port_id = self.cur_rep.port_id

	model = self.host_view.get_model()
	path0 =  self.host_view.get_cursor()[0][0]

	path0 += 1
	while( path0 < len(model) ):
	    if( model[path0][Rep_host.COL_problem] != None ):

		self.host_view.set_cursor((path0,))
		self.update_port_store(port_id)
		self.update_rep_store(rep_id)
		self.update_text()

		return
	    path0 += 1

	#nic
	

    def modbar_callback(self, panned, property):

	if( self.hpaned3.get_position() > 0 ) :
	    self.buttonM.set_label('<')
	else:
	    self.buttonM.set_label('>')
	    
	    

	

    def toggle_modules(self, widget = None):

	if( self.hpaned3.get_position() > 0 ):
	    self.hpaned3.set_position(0)
	else:
	    self.hpaned3.set_position(200)
	
	return True
    def set_text(self, text):

	self.save_cur_rep_note()
	self.update_text_lo(text) 


    def toggle_help(self, widget = None):

	self.not_help = not( self.not_help)

	if(self.not_help):
	    self.update_text()
	    return

	self.save_text( """
Key help:

j,k -- next/previous report
h,l -- next/previous port
n,p -- next/previous host
[,] -- next/previous host with the same problem
u,~ -- toggle unchecked|again|false positive|positive
v   -- view script source (if any)
#   -- print ports of current host (stdout)
i,a -- insert/append mode (Escape returns)
f,b -- page forward/backward
G   -- group/ungroup selected ports
<,> -- toggle modules bar

q   -- quit
s   -- save additional info to nerv.rep
?   -- show/hide this help

To activate links, can, cve, bids double click on it.
Host's group, short name, DSN and port's service can be changed.

au: vitas
http://vitas.matfyz.cz/
	""")

    def print_rep(self):
	for host in self.report.values():
	    print host.name
	    for port in host.ports.values():
		print "  ", port.id
		for rep in port.reps.values():
		    print "     ", rep.rep_id


    def esc_key_callback(self, widget, event):

	if( (event.type !=  gtk.gdk.KEY_PRESS) ) :
	    print "nejaky divny event:", event.type
	    return False
	key = gtk.gdk.keyval_name(event.keyval) 
	#print"key:", key

	if(   key == 'Escape'):
	    #print"host_view.activate()"
	    self.host_view.grab_focus()
	    return True

	return False

    def window_key_callback(self, widget, event):

	if( (event.type !=  gtk.gdk.KEY_PRESS) ) :
	    print "nejaky divny event:", event.type
	    return False

	#if( (event.state != 4 ) ) :
	#    return False
	key = gtk.gdk.keyval_name(event.keyval) 

#	if(   key == 'p'):
#	    print "----"
#	    self.host_view.get_model()[(0,)][Rep_host.COL_group] = "D"
#	    self.host_view.get_model().set_sort_column_id(
#			3,
#			gtk.SORT_DESCENDING)
#	    self.host_view.get_model().set_sort_column_id(
#			3,
#			gtk.SORT_ASCENDING)

	if   key == 'j':
	    self.next_rep()

	elif key == 's' :
	    self.save_changes()

	elif key == 'k' :
	    self.prev_rep()

	elif key == 'h' :
	    self.next_port()

	elif key == 'l' :
	    self.prev_port()

	elif key == 'n' :
	    self.next_host()

	elif key == 'p' :
	    self.prev_host()

	elif key == 'q' :
	    gtk.mainquit()

	elif key == 'P' :
	    self.print_rep()

	elif key == 'y' :
	    self.print_cur_ports()

	elif key == 'u' or key == 'asciitilde':
	    self.change_check()

	elif key == 'v' :
	    self.view_script()

	elif key == 'i' :
	    self.insert_mode()

	elif key == 'a' :
	    self.insert_mode(True)

	elif key == 'bracketleft' :
	    self.prev_problem()

	elif key == 'bracketright' :
	    self.next_problem()

	elif key == 'question'  :
	    self.toggle_help()

	elif key == 'greater' or key == 'less' :
	    self.toggle_modules()

	elif key == 'w' :
	    print "cur_port.name:", self.cur_port.name
	    #print "p1:", self.hpaned1.get_position()
	    #print "p2:", self.hpaned2.get_position()

	elif key == 'f':
	    #self.text.emit("insert-at-cursor", "kuk");
	    self.text.emit("move-cursor", gtk.MOVEMENT_PAGES, 1, False);

	elif key == 'b':
	    self.text.emit("move-cursor", gtk.MOVEMENT_PAGES, -1, False);

	elif key == 'G':
	    self.group_ports()

	else:
	    #print "key:", key
	    return False

	return True

    def insert_mode(self, append = False):

	self.text.grab_focus()
	
	tbuffer = self.text.get_buffer()
	beg = tbuffer.get_start_iter()
	beg.forward_to_tag_toggle(tbuffer.get_tag_table().lookup('pozn'))

	if append :
	    beg.forward_to_tag_toggle(tbuffer.get_tag_table().lookup('pozn'))
	    beg.backward_char()
	else :
	    beg.forward_char()

	tbuffer.place_cursor(beg)

	

    def print_cur_ports(self):
	ports =  [port.portnum for port in self.cur_host.ports.values()]
	ports.sort();

	print "\host:", self.cur_host.name

	for port in ports:
	    if port != 0:
		print "\\port:", port
	
    def group_ports(self, widget = None):

	model = self.port_view.get_model()
	sel = self.port_view.get_selection()

	all = []

	iter = model.get_iter_first()
	while iter != None:
	    if sel.iter_is_selected(iter) :
		port = model[iter][Rep_port.COL_self]
		#print "G:" + port.name

		all.append(port.id)

	    iter = model.iter_next(iter)
	
	if len(all) == 0:
	    return

	elif len(all) == 1:
	    self.group_ports_ungroup(self.cur_host, all[0])

	else:
	    self.group_ports_group(self.cur_host, all)

	self.update_port_store(all[0])

	return None

    def group_ports_ungroup(self, host, fst):
	port = host.ports[fst]
	# ungroup
	for p in port.group: 
	    port = host.ports[p]
	    port.group = [ port.id ] 
	    port.name = port.my_name

    def group_ports_group(self, host, all):

	fst = all[0]
	port = host.ports[fst]
	port.group = all
	port.name = string.join(all, '\n')

	for p in all[1:]: 
	    port = host.ports[p]
	    port.name = "-" + port.my_name
	    port.group = []
	    #print "[", port.name, "]"


    def change_check(self, widget = None):

	self.cur_rep.set_check_next()
	self.update_cur_cursor(self.rep_view);
	self.status_line( 
		self.cur_host.ip +  "|" +
		self.cur_port.id +  "|" +
		self.cur_rep.rep_id + 
		" is now '" + 
		self.cur_rep.get_check_as_char() +
		"'")

	if( self.cur_port.update_check(self.cur_rep.check)):
	    self.update_cur_cursor(self.port_view)

	    if( self.cur_host.update_check(self.cur_rep.check) ):
		self.update_cur_cursor(self.host_view)

	#print "check", self.cur_rep.check, self.cur_host.check

    def update_cur_cursor(self, tree):
	model, iter = self.get_fst_selected(tree)
	model[iter][0].update_in_store(model, iter)


    def view_script(self, widget = None):
	script = self.cur_rep.script
	if( script != None ):
	    self.system("gvim " + nessus_plugins_dir + script)

    def system(self, cmd):
	os.system(cmd)
	self.status_line("$ " + cmd)

    def run_url(self,url):
	cmd = "netscape --remote 'openURL(" + url +",new-tab)'"
	self.system(cmd);

    def tag_cb_zpracuj(self, tag, event, iter):

	if( (event.type != gtk.gdk._2BUTTON_PRESS) or (event.button != 1) ):
	    return None

	beg = iter.copy()
	end = iter.copy()

	beg.backward_to_tag_toggle(tag);
	end.forward_to_tag_toggle(tag);

	if( not(beg) or not(end) ) :
	    return None

	txt = self.text.get_buffer().get_text(beg, end, False)
	return txt


    def tag_bid_callback(self, tag, widget, event, iter):
	txt = self.tag_cb_zpracuj(tag, event, iter)
	if( txt != None ):
	    print "[" + txt + "]"
	    self.run_url("http://www.securityfocus.com/bid/"+txt)

    def tag_cancve_callback(self, tag, widget, event, iter):
	txt = self.tag_cb_zpracuj(tag, event, iter)
	if( txt != None ):
	    print "[" + txt + "]"
	    self.run_url("http://icat.nist.gov/icat.cfm?cvename="+txt)

    def tag_url_callback(self, tag, widget, event, iter):

	txt = self.tag_cb_zpracuj(tag, event, iter);
	if( txt != None ):
	    print "[" + txt + "]"
	    self.run_url(txt)

    def rep_callback(self, widget, data=None):
	if( self.cb_forbiden ): return

	self.cb_forbiden = True

	model,  iter = widget.get_selection().get_selected();
	self.set_cur_rep(model[iter][0])

	self.update_text()
	self.update_host()

	self.cb_forbiden = False


    def port_callback(self, widget, data=None):

	if( self.cb_forbiden ): return
	self.cb_forbiden = True

	model,  iter = self.get_fst_selected(widget)
	self.cur_port = model[iter][0]

	self.update_rep_store()
	self.update_text()
	self.update_host()

	self.cb_forbiden = False

    def host_callback(self, widget, data=None):

	if( self.cb_forbiden ): return
	self.cb_forbiden = True

	model,  iter = widget.get_selection().get_selected();
	self.cur_host = model[iter][0]
	self.update_port_store()
	self.update_rep_store()
	self.update_text()
	self.update_host()

	self.cb_forbiden = False

    def update_host(self):

	port = self.cur_rep.port_id
	rep = self.cur_rep.rep_id


	for row in self.host_view.get_model():
	    host = row[0];

	    host.problem  =False

	    if( port in host.ports ):
		if(rep in host.ports[port].reps ):
		    host.problem = True;

	    row[Rep_host.COL_problem] = host.problem_pic()

    def update_text(self):
	
	model,  iter = self.rep_view.get_selection().get_selected();
	self.update_text_lo(self.cur_rep.txt, self.cur_rep.note, True)


	if( self.cur_rep.script == None ):
	    self.buttonV.set_label("none");
	else:
	    label = self.cur_rep.script.replace('_', '__')
	    self.buttonV.set_label(label)

    def update_text_lo(self, txt, note = '\n', disp_head = False):

	tbuffer = self.text.get_buffer()

	tbuffer.set_text("\n"+txt)

	self.otaguj(tbuffer, 'url', 'http://')
	self.otaguj(tbuffer, 'cancve', 'CVE-', )
	self.otaguj(tbuffer, 'cancve', 'CAN-')

	self.otaguj_bid(tbuffer)
	beg = tbuffer.get_start_iter()

	if disp_head:
	    head = self.cur_host.ip + " " + \
		("%i " % self.cur_port.portnum) + \
		self.cur_host.dns + " " + \
		self.cur_rep.port_id + " " + \
		self.cur_rep.cves + " " + \
		self.cur_rep.rep_id

	    tbuffer.insert_with_tags_by_name(beg, head+"\n", 'head')
	    #self.status_line(head)

	    note = "* " + note + "\n";

	    tbuffer.insert_with_tags_by_name(beg, note, 'pozn')
	    tbuffer.place_cursor(tbuffer.get_start_iter())

	tbuffer.apply_tag_by_name('norm',
	    tbuffer.get_start_iter(),
	    tbuffer.get_end_iter())

    def otaguj_bid(self, tbuffer):

	end = tbuffer.get_start_iter()
	found = end.forward_search("BID", gtk.TEXT_SEARCH_VISIBLE_ONLY)
	
	if(found == None):
	    return
	beg, end = found

	c = end.get_char()
	while c in " :" :
	    end.forward_char() 
	    c = end.get_char()

	# nyni muze nasledovat seznam 888, 111, 22\n

	count = 16
	while count > 0 : 
	    count -= 1

	    #skip space
	    while c in ", " :
		end.forward_char() 
		c = end.get_char()

	    # dalsi slovo zacina ne-cislem: padame pryc
	    if( not c.isdigit() ) :
		return

	    beg = end.copy()

	    while c.isdigit() :
		end.forward_char() 
		c = end.get_char()

	    tbuffer.apply_tag_by_name('bid', beg, end)

	print "more than 16 BIDs, carrot in winter..."

    def otaguj(self, tbuffer, tagname, prefix):

	end = tbuffer.get_start_iter()

	found = end.forward_search(prefix, gtk.TEXT_SEARCH_VISIBLE_ONLY)

	while(found != None):
	    beg, end = found
	    end.forward_word_ends(0)

	    c = end.get_char()
	    while( c not in '\0\n, ' ):
		end.forward_char() 
		c = end.get_char()

	    tbuffer.apply_tag_by_name(tagname, beg, end)
	    
	    found = end.forward_search(prefix, gtk.TEXT_SEARCH_VISIBLE_ONLY)

    # This callback quits the program
    def delete_event(self, widget, event, data=None):
        gtk.main_quit()
        return gtk.FALSE

    def get(self, hostname, portname, repname):

	host = self.report.get(hostname)
	if( host == None ):
	    return None

	port = host.ports.get(portname)
	if( port == None ):
	    return None


	rep = port.reps.get(repname)
	if( rep == None ):
	    return None

	return rep


    def add_report(self, row):
	if len(row) == 6:
	    if row[0] == 'timestamps':

		typ, net, hostname, end, date, nic = row

		if  end in [ 'host_start', 'host_end']:
		    host = self.report.get(hostname)
		    if host == None:
		       host = self.report[hostname] = Rep_host(hostname)
		    host.add_end( end, date )

	    return
	if len(row) !=  7 :
	    return
	typ, net, hostname, portname, script, ser, reptxt = row

	ser = { "Security Warning": "W",
		"Security Hole":    "H",
		"Security Note":    "N" }.get(ser, "X");

	portid, sername, portnum, proto = Rep_port.to_portname(portname)
		
	host = self.report.get(hostname); 

	if(  host == None ):
	   self.report[hostname] = host = Rep_host(hostname)
	    
	port = host.ports.get(portid);
	if( port == None ):
	    host.ports[portid] = port = \
		Rep_port(portid, sername, portnum, proto)

	rep_id = script + "-" + ser;
	rep = port.reps.get(rep_id);
	if( rep == None) :
	    port.reps[rep_id] = Rep_rep(portid, portnum,
					rep_id, script,
					ser, reptxt)
	else:

	    port.reps[rep_id].add_note(reptxt)

	self.rep_num += 1
	
    def load_script_nums(self):
	global script_nums
	script_nums = {}
	f = open(nerv_lib_dir + "script-nums.txt")
	if f == None:
	    return
	row = f.readline()
	while( len(row) > 0):
	    num, scriptname = row.split(':', 1)

	    script_nums[num] = scriptname.rstrip()
	    row = f.readline()
	f.close()
	    
	    
	
    def parse(self, filename):
	self.rep_num = 0
	f = file(filename, 'r')
	row = f.readline()
	while( len(row)  > 0 ) :
	    row2 = row.split('|',7)
	    self.add_report(row2)
	    row = f.readline()
	f.close();

    def compute_security_and_check(self):
	for host in self.report.values():
	    for port in host.ports.values():
		port.compute_security()
		port.compute_check()
	    host.compute_security()
	    host.compute_check()
	
    def update_host_store(self):

	model = self.host_view.get_model()
	model.clear()

	for v in self.report.values():
	    v.add_to_store(model);

	self.host_view.set_cursor((0,), None, False)
	model,  iter = self.host_view.get_selection().get_selected();
	self.cur_host = model[iter][0]

    def update_port_store(self, row_val = None):

	model = self.port_view.get_model()
	model.clear()

	idx = None

	keys = self.cur_host.ports.keys()
	#keys.sort();
	for k in keys:
	    port = self.cur_host.ports[k]
	    #if len(port.group) > 0 :
	    if True:
		iter = port.add_to_store(model)
		if(k == row_val):
		    self.port_view.set_cursor(model.get_path(iter), None, False)
		
	if row_val == None:
	    self.port_view.set_cursor((0,), None, False)

	#model, iter = self.port_view.get_selection().get_selected();
	model, iter = self.get_fst_selected(self.port_view)
	self.cur_port = model[iter][0]

    def get_fst_selected(self, tree_view):
	model = tree_view.get_model()
	sel = tree_view.get_selection()

	iter = model.get_iter_first()
	while iter != None:
	    if sel.iter_is_selected(iter) :
		return model, iter
	    iter = model.iter_next(iter)

	print "get_fst_selected: none, none"
	
	return None



    def update_rep_store(self, row_val = None):

	model = self.rep_view.get_model()
	model.clear()


	#group = self.cur_port.group
	group = [self.cur_port.id]

	if len(group) == 0 :
	    print"update_rep_store: group == 0"

	for p in group:

	    port = self.cur_host.ports[p]

	    for r in port.reps.keys():
		iter =  port.reps[r].add_to_store(model)
		if(r == row_val):
		    self.rep_view.set_cursor(model.get_path(iter), None, False)

	    if row_val == None:
		self.rep_view.set_cursor((0,), None, False)

	model, iter = self.rep_view.get_selection().get_selected();
	self.set_cur_rep(model[iter][0])


    def save_cur_rep_note(self):

	if( self.cur_rep != None ):

	    tbuffer = self.text.get_buffer()
	    beg = tbuffer.get_start_iter()

	    beg.forward_to_tag_toggle(tbuffer.get_tag_table().lookup('pozn'))
	    end = beg.copy()
	    end.forward_to_tag_toggle(tbuffer.get_tag_table().lookup('pozn'))

	    note =  tbuffer.get_slice(beg, end, gtk.FALSE)
	    #note = note.strip()

	    if len(note) > 0:
		if note[0] == "*":
		    note = note[1:]

	    note = note.strip();
	    self.cur_rep.note = note

    def set_cur_rep(self, new_rep):
	self.save_cur_rep_note()
	self.cur_rep = new_rep

    def port_svc_edit_cb(self, old, path, new, model):
	model.get_value(model.get_iter(path),
	    Rep_port.COL_self).svc_name = new
	model.set_value(model.get_iter(path), Rep_port.COL_svc_name, new)

    def host_group_edit_cb(self, old, path, new, model):
	model.get_value(model.get_iter(path), Rep_host.COL_self).group = new
	model.set_value(model.get_iter(path), Rep_host.COL_group, new)

    def host_short_edit_cb(self, old, path, new, model):
	model.get_value(model.get_iter(path), Rep_host.COL_self).short = new
	model.set_value(model.get_iter(path), Rep_host.COL_short, new)

    def host_dns_edit_cb(self, old, path, new, model):
	model.get_value(model.get_iter(path), Rep_host.COL_self).dns = new
	model.set_value(model.get_iter(path), Rep_host.COL_dns, new)

    def create_host_view(self):

	tree = Rep_host.create_tree();

        tree.connect("cursor-changed", self.host_callback, "button 1")
	model = tree.get_model();
	self.host_view  = tree

	tree.short_renderer.connect("edited", self.host_short_edit_cb, model)
	tree.dns_renderer.connect("edited", self.host_dns_edit_cb, model)
	tree.group_renderer.connect("edited", self.host_group_edit_cb, model)

	return  self.opicky_view(tree);

    def create_port_view(self):

	tree = Rep_port.create_tree();
	model = tree.get_model();

	tree.get_selection().set_mode(gtk.SELECTION_MULTIPLE)

	tree.svc_renderer.connect("edited", self.port_svc_edit_cb, model)
        tree.connect("cursor-changed", self.port_callback, "button 1")

	self.port_view  = tree
	return  self.opicky_view(tree);

    def create_rep_view(self):

	tree = Rep_rep.create_tree();
        tree.connect("cursor-changed", self.rep_callback, "button 1")
	self.rep_view  = tree
	return  self.opicky_view(tree);

    def opicky_view(self, tree):

	#tree.set_reorderable(gtk.TRUE)
	tree.set_headers_visible(gtk.TRUE)
	#tree.set_reorderable(gtk.TRUE)

	scro = gtk.ScrolledWindow()
	scro.add(tree)
	scro.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
	#scro.set_policy(gtk.POLICY_ALWAYS,gtk.POLICY_ALWAYS)
	#scro.show()
	tree.show()
	return scro



    def init_pix(self):

	global pixbuf
	pixbuf = {}
        pixbuf['kniha'] = gtk.gdk.pixbuf_new_from_xpm_data(book_closed_xpm)
	
	for i in (
	    'mozek_small',
	    'computer',
	    'error_small',
	    'error',
	    'info_small',
	    'info',
	    'lock',
	    'nessus',
	    'network',
	    'nothing',
	    'orange',
	    'red',
	    'user',
	    'warning_small',
	    'warning',
	    'white',
	    'minus',
	    'bang',
	    'question',
	    'plus',
	    'yellow'):

	    pixbuf[i] =   gtk.gdk.pixbuf_new_from_file(
				nerv_lib_dir + "xpm/"+i+".xpm")

class Repp:

# %|HOST|ip,s|shortname|pozn.
# %|PORT|ip|port,s

    def add_note(self, row, autotext):

	row_split = row.split('|', 4)

	if( len(row_split) !=  5):
	    print self.line, ":bad note syntax:[", row , "]"
	    return False

	hostname, portname, repname, check, txt = row_split

	rep = self.nv.get(hostname, portname, repname)
	if( rep == None ):
	    print self.line, ":neznamy report:", \
	          hostname, "|", portname, "|", repname
	    return False

	idx = txt.find("\n")
	if idx > 0:
	    rep.note = txt[idx:]

	rep.note = rep.note.strip()
	rep.set_check_as_char(check) 

	#print "rep:", hostname, rep.port_id, rep.rep_id, txt,
	#print rep.txt

	self.text.append(['rem', hostname, portname, repname, txt, autotext])
	self.rep_count += 1

	return True

    # %|HOST|IP|DNS|short|group
    #       |<---data--->|

    def add_host(self, data):
	row_split = data.split('|', 3)

	ip = row_split[0]

	if ip not in self.nv.report :
	    return False

	host = self.nv.report[ip]

	if len(row_split) > 1:
	    host.dns  = row_split[1]

	if len(row_split) > 2:
	    host.short  = row_split[2]

	if len(row_split) > 3:
	    host.group  = row_split[3]
	
	return True
	
    # %|PORT|IP|port;port|
    #       |<---data--->|
    # port := NUM '/' ('tcp' | 'udp' )( PROTO  )?
    # 80/tcp(http), 123/udp apod
    def add_port(self, data):

	row_split = data.split('|', 3)

	ip = row_split[0]

	if ip not in self.nv.report :
	    return False

	host = self.nv.report[ip]

	ports = self.portsplit(row_split[1])

	for port, svc in  ports:
	    if port not in host.ports:
		print"no port",port,"in host",host.name
		return False

	for port, svc in  ports:
	    if svc != '':
		host.ports[port].svc_name = svc
    
	if len(ports) > 1: 
	    self.nv.group_ports_group(host, [p for p,s in ports])

# 	host.group_ports
# 	port = ports[0][0]
# 
# 	ports = row_split[1].split(';')
# 
# 	if len(ports) == 0:
# 	    return False
# 
# 	for pp in  ports:
# 
# 	    port, p.split 
# 	    
# 	    if p not in host.ports:
# 		return False
# 
# 	
# 	port = host.ports[ports[0]]
# 	port.group = ports
# 	port.name = string.join(ports, '\n')
# 
# 	for p in ports[1:]: 
# 	    port = host.ports[p]
# 	    port.name = "-" + port.my_name
# 

    # r: [ 0..3, narezane parametry (if any)  ]

    def portsplit(self, ports):

	pp = ports.split(';')
	ret = []

	for p in pp:
	    ss = p.split('(', 1);
	    if len(ss) == 1:
		ret.append([ss[0], '' ] )
	    else:
		ret.append([ss[0], ss[1].rstrip(')') ])

	return ret

    # lexemy:
    LX_empty = 0
    LX_text  = 1
    LX_head  = 2
    LX_multi = 3

    # stavy:
    ST_top = 0
    ST_data = 1
    ST_auto = 2

    # vrati ntici:
    # 0 typ (empty, text, data, multi)
    # 1 vlastnitext 
    #
    # u data:
    # 0 typ (data)
    # 1 datatyp (HOST, '', PORT, ...)
    # 2 zbytek

    def load_file_lex(self,  row):

	row = row[:-1] # chomp

	#empty line
	if len(row.strip()) == 0 :
	    return [Repp.LX_empty, row]

	# multi line
	if row[:3] == '%+ ':
	    return [Repp.LX_multi, row[3:] ]
	if row[:2] == '%+':
	    return [Repp.LX_multi, row[2:] ]

	# text
	if row[:2] != '%|':
	    return [ Repp.LX_text, row ]

	args = row.split('|', 2)

	# text again
	if len(args) <= 2 :
	    return [ Repp.LX_text, args[1] ]
	    
	# data_head
	return [ Repp.LX_head, args[1], args[2]]

    def load_file_text(self, txt):
	self.text.append(["txt", txt])

    def load_file_data(self, datatyp, data, autotext):

	if datatyp == '' :
	    if not self.add_note(data, autotext) :
		self.text.append(['err', data, autotext])
	elif datatyp == 'HOST':
	    self.add_host(data)

	elif datatyp == 'PORT':
	    self.add_port(data)
	else:
	    self.text.append(['%', datatyp, data, autotext])

    # nahraje soubor,
    # format souboru:
    #
    # file := ( blok | text ) *
    # blok := blok_head . ( blok_data ) * . (blok_text)*
    #
    # text := ^.*$
    # blok_head := ^%|BLOK-TYPE|.*$
    # blok_data := ^%+.*$
    # blok_auto := ^\s*\S+.*$ (neprazdny radek)
    # 
    # lex:    <empty line>, <text>, %||,    %+
    #           empty         text   head    multi
    # state:
    # top,      top           top   data     top
    # data      top(f)        auto  data(f)  data
    # auto      top(f)        auto  data(f)  auto
    #
    # (f) flush blok_typ, blok_txt
    def load_file(self, filename):

	if not os.path.exists(filename):
	    return

	self.rep_count = 0 
	self.text = []

	f = file(filename, 'r')
	state = Repp.ST_top
	data = ""
	autotext = ""

	self.line = 0
	for row in f:
	    self.line += 1

	    lex = self.load_file_lex(row)

	    if lex[0] == Repp.LX_head:

		if state != Repp.ST_top:
		    self.load_file_data(datatyp, data, autotext)

		datatyp = lex[1]
		data = lex[2]
		autotext = ""
		state = Repp.ST_data

	    elif lex[0] == Repp.LX_multi:

		if state == Repp.ST_top:
		    self.load_file_text("%+ " + lex[1])

		elif state == Repp.ST_data:
		    data += "\n" + lex[1]

		elif state == Repp.ST_auto:
		    autotext += lex[1]

	    elif lex[0] == Repp.LX_empty:

		if state != Repp.ST_top:
		    self.load_file_data(datatyp,data, autotext)

		self.load_file_text(lex[1])
		state = Repp.ST_top

	    elif lex[0] == Repp.LX_text:

		if state == Repp.ST_top:
		    state = Repp.ST_top
		    self.load_file_text(lex[1])

		else:
		    state = Repp.ST_auto
		    autotext += "\n" + lex[1]
		    
	if state != Repp.ST_top:
	    self.load_file_data(datatyp, data, autotext)
	f.close()


    def host_split(self, row):

	ret = [ row ] 

	args = row.split(':',2)[-1].split('%',2);
	hosts =  args[-1].split(';')

	if len(args) == 1 :
	    # vezmi jen kazdy druhy argument
	    hosts = [ hosts[i] for i in range(1,len(hosts),2) ] 

	# jen kazdy druhy argument je ip
	return ret + [ host.strip() for host in  hosts ] 
	
    def port_split(self, row):

	arg = row.split(':',2)[-1].split('%',2)[-1];
	ports =  arg.split(';')
	ret = [ row ] 

	for port in ports:
	    port = port.strip()

	    port_bez = port[:-1]

	    if port[-1] == 'u':
		ret.append(port_bez + "/udp")

	    elif port[-1] == '*':

		ret.append(port_bez + "/udp")
		ret.append(port_bez + "/tcp")

	    else:
		ret.append(port + "/tcp")
		
	return ret

    def save_rem(self, row):
	typ, host, port, repname, txt, autotext = row

	rep = self.nv.get(host, port, repname)

	if rep == None:
	    print "oups, remark disappeared" 
	    return

	check = '-'
	check = rep.get_check_as_char()

	ret = "%||" + host + "|" + port + "|"  + repname  + "|"
	ret += check + "|" + txt.replace("\n", "\n%+")  + autotext

	return ret + "\n"
	
	
    def save_backup(self, filename):

	    
	backname = filename + "~";
	backnum = 1

	while( os.path.exists(backname) ):
	    backnum += 1
	    backname = filename + "~%i" % backnum

	shutil.copy(filename, backname)
	

    def save_template_port_save_name(self, host, ports):
	ret = []

	for p in ports:
	    if host.ports[p].svc_name == '':
		ret.append( p )
	    else:
		ret.append( p + "(" + host.ports[p].svc_name + ')' );

	return string.join(ret, ';')

    def save_template(self, filename):

	self.save_backup(filename)

	f = file(filename, "w+")
	rep_saved = 0
	
	for host in self.nv.report.values():
	    for port in host.ports.values():
		for rep in port.reps.values():
		    rep.is_saved = False

	#for host in self.nv.report.values():
	for host in Rep_base.sort(self.nv.report):

	    ip =  host.ip
	    dns =  host.dns
	    sh =  host.short
	    gr = host.group
	    f.write("%|HOST|" + ip + "|" + dns + "|" + sh + "|" + gr + "\n");
	    #f.write("%|HOST|" + ip + "|" + dns + "|" + sh + "\n");
	    f.write("\\host:" + sh + ";" + ip + "\n\n");
	    
	    for port in Rep_base.sort(host.ports):

		ports = port.group
		pnames = self.save_template_port_save_name(host, ports)
		#print "st:", port.name,":", len(port.group)

#%|PORT|61.41.0.106|80/tcp(http);80/tcp;8080/tcp;8081/tcp
#\porty: 80/tcp(http);8080/tcp(http);8081/tcp(https)

		if len(ports) > 0: 
		    f.write("%|PORT|" + ip + "|" + pnames + "\n");
		    f.write("\port: " + pnames + "\n\n");

		for port2_id in ports:
		    port2 =  host.ports[port2_id]
		    for rep in Rep_rep.sort_save(port2.reps):
			if (rep.check != CH_unchecked) | (rep.note != ""):
			    if( rep.is_saved == True ):
				print "saving twice:", \
				    host.ip ,port.name,rep.rep_id

#%||61.41.0.106|80/tcp|11030-H|-|to je vazne skandal

			    note = rep.note.strip()
			    cves = rep.cves
			    if  note != '':
				note =  cves + "\n%+ " + \
				        note.replace("\n","\n%+ "); 

			    f.write("%||" +
				ip + "|" +
				rep.port_id + "|" +
				rep.rep_id + "|" +
				rep.get_check_as_char() + "|" +
				note + "\n")
			    rep.is_saved = True
			    rep_saved += 1
		f.write("\n");

	for host in Rep_base.sort(self.nv.report):
	    for port in Rep_base.sort(host.ports):
		for rep in Rep_base.sort(port.reps):
		    if (rep.check != CH_unchecked) | (rep.note!='') :
			if( rep.is_saved == False ):
			    print "rep is not saved:", \
				host.name,port.name,rep.rep_id
			
	print "reps loaded: %i" % self.rep_count
	print "reps saved : %i" % rep_saved 


	
    def save_file(self, filename):

	for host in self.nv.report.values():
	    for port in host.ports.values():
		for rep in port.reps.values():
		    rep.was_saved = False


	hosts = []
	ports = []
	
	f = file(filename, "w+")

	for row in self.text:
	    print row

	for row in self.text:

	    tag = row[0]

	    if tag == 'rem':
		f.write(self.save_rem(row))

	    elif tag == 'err':
		print row

	    elif tag == 'txt':
		f.write(row[1] + "\n")

	    elif tag == '%':

		if row[1] == "HOST":
		    cur_hosts = row[2]

		elif row[1] == "PORT":
		    pass


		datatxt = row[2].replace('\n', "\n%+")
		f.write("%|" + row[1] + "|" + datatxt + "|" + row[3] + "\n")

	    elif tag == 'host-oth':
		self.save_host_oth()

	    else:
		print "?", row

	f.close()


    def save_host_oth(self):
	
	for host in self.nv.report.values():
	    host_printed = False
	    for port in host.ports.values():
		port_printed = False
		for rep in port.reps.values():


		    if not rep. was_saved :
			if not host_printed:
			    print "\host:" + host.name + "\n"
			if not port_printed:
			    print "\port:" + port.name + "\n"
			self.save_note(host, port, rep)

			host_printed = True
			port_printed = True


			
    def save_note(self, host, port, rep):

	check = rep.get_check_as_char()
	note = rep.note

	print"%||"+host.name+"|"+port.id+"|"+rep.rep_id+"|"+check+"|"+note+"\n"
			

    def print_template(self):

	for row in self.text:
	    print '[', row[0], ']:', row[1:]

    def __init__(self, filename, nv):
	self.nv = nv
	self.text = []

	self.load_file("nerv.rep")
	#self.print_template()
	#self.save_file("ahoj.rep")



class Module:

    name = "Default"
    widget = None
    #param = []
    param = [ \
       [ "list" , "J", 'hruska',  ["jabko", "hruska", "svestka"] ],  \
       [ "check" , "O",  True, "ovoce"  ],  \
       [ "check" , "Z",  False, "zelenina"  ],  \
       [ "check" , "B",  True, "barvy"  ],  \
       [ "check" , "L",  True,  "laky"  ],  \
       [ "input" , "#",  '16', "pocet" ]
       ] 

    def __init__(self, nv):
	self.nv = nv

    values = {};

    def table_text(self, table):

	line_max = []

	row0  = table[0]

	for  i  in range( len(table[0]) ) :
	    max = 0
	    for j in range(len(table)):
		#if len(row0) != len(table[j]):
		if table[j][i] == "":
		    table[j][i] = '.'

		if len(table[j][i]) > max:
		    max = len(table[j][i])
	    line_max.append(   ( 1 + int(max/8) ) )
	
	ret = ''
	for j in range( len(table) ):
	    for i in range( len(table[j]) - 1 ):
		tabs = line_max[i] - ( len(table[j][i])/8 )
		ret += table[j][i] + ("\t" * tabs)
	    ret += table[j][-1] + "\n"

	return ret
		
    def more_button(self, button, content):
	if button.get_label() == ">>":
	    content.show()
	    button.set_label("<<")
	else:
	    content.hide()
	    button.set_label(">>")


    def go_button(self, button):


	#print "go_button"
	#print self.param

	ret = {}
	
	for p in self.param:
	    if len(p) != 5: 
		continue

	    typ, name, val, label, wid = p

	    if typ == "check":

		val = wid.get_active() 

		ret[name] = val

		#print name, "(check):", ret[name]

	    elif typ == "list" :
		val = wid.entry.get_text()
		#print name, "(list):", val
		ret[name] = val
		
	    elif typ  == "input" :
		ret[name] = wid.get_text()
		#print name, "(input):", ret[name]
	    
	
	self.nv.set_text(self.get_text(ret))

	return True;

    def get_text(self, vals):
	ret = ''
	for v in vals:
	    ret += v + ":" + str(vals[v]) + "\n";

	return ret;



    def create_widget(self):

	self.frame = gtk.Frame()

        title = gtk.Button(self.name);
	title.connect("clicked", self.go_button)

	if len(self.param) == 0:

	    self.frame.add(title)
	    title.show()
	    self.frame.show()
	    return self.frame

	vbox = gtk.VBox()
	vbox2 = gtk.VBox()


	hbox = gtk.HBox()



        more  = gtk.Button(">>");

	hbox.pack_start(title)
	hbox.pack_start(more, False)

	title.show()
	more.show()

	vbox.pack_start(hbox);
	hbox.show()

	for p in self.param:

	    if len(p) != 4: 

	        if p[0] == "separator" :
		    sep = gtk.HSeparator()
		    vbox2.pack_start(sep)
		    sep.show()

	        continue

	    typ, name, val, lab = p

	    if typ == "list":

		combo = gtk.Combo()
		combo.set_popdown_strings(lab)
		combo.set_value_in_list(True, False)

		vbox2.pack_start(combo)
		combo.show()
		p.append(combo)

	    elif typ == "check":
		ch = gtk.CheckButton(lab)
		ch.set_active(val)
		vbox2.pack_start(ch)
		ch.show()
		p.append(ch)

	    elif typ  == "input":
		hbox = gtk.HBox()

                text =  gtk.Entry()
		text.set_text(val)
		text.set_width_chars(8)
		hbox.pack_start(text, False)
		text.show()

		label = gtk.Label(lab)
		hbox.pack_start(label, False)
		label.show()

		vbox2.pack_start(hbox)
		hbox.show()
		p.append(text)


	vbox.pack_start(vbox2)

	#more.options = vbox2

	vbox2.hide()


	more.connect("clicked", self.more_button, vbox2)

	vbox.show()
	self.frame.add(vbox)
	  
        self.frame.show()

        return self.frame

class Module_kuk(Module):

    param = [ ]
    name = "Module Kuk"

    def get_text(self, vals):
	return "ahooooooooooooooooj"


class Module_hosts(Module):
    name="Hosts list"
    param = [
	[ "check", "short", True , "Short" ],
	[ "check", "ip",    True , "IP" ],
	[ "check", "dns",   True,  "DNS" ],
	[ "check", "empty", False, "Epmpty" ],
	[ "check", "ports", False, "Ports" ],
	]

    def get_text(self, vals):

	tab = []

	for h in self.nv.get_hosts().values():
	    row =  []

	    if vals['short'] :
		row.append(h.short)

	    if vals['ip'] :
		row.append(h.ip)

	    if vals['dns'] :
		row.append(h.dns)

	    if vals['empty'] :
		row.append('')

	    if vals['ports'] :
		row.append(self.ports(h))

	    tab.append(row)
	    
	return "\\table:\n" + self.table_text(tab)

    def ports(self, host):
	ret = ''
	for p in host.ports.values():
	    if p.name[0:3] == "gen":
		continue
	    ret += " " + p.name

	return ret[1:]

class Module_general(Module):

    name="General Problems"
    param = [
	[ "check", "short", True,   "Short" ],
	[ "check", "ip",    False,   "IP" ],
	[ "check", "dns",   False,   "DNS" ],
	[ "check", "empty", False,   "Empty" ],
	[ "separator" ],
	[ "check",  "ts",    True,   "ICMP timestamp" ],
	[ "check",  "sf",    True,   "SYN FIN" ],
	[ "check",  "sr",    True,   "Source routed" ],
	[ "check",  "nr",    True,   "non random IP ID" ],
	[ "check",  "sq",    True,   "TCP SEQ" ],
	[ "check",  "mr",    True,   "ICMP MASKREQ" ],
	]

    head = [ 
	['short',    'Host'],
	['ip',	    'IP'],
	['dns',	    'DNS'],
	['empty',  '' ],
	['ts',	    'ICMP TS' ],
	['sf',	    'SYN FIN' ],
	['sr',	    'Source routed' ],
	['nr',	    'IP ID' ],
	['sq',	    'TCP SEQ' ],
	['mr',	    'ICMP_MASKREQ' ],
	]

    def get_text(self, vals):


	myhead  = [ x[1] for x in self.head  if( vals[ x[0] ] ) ]
	tab = [ myhead ]

	for h in self.nv.get_hosts().values():
	    row =  []

	    if vals['short'] :
		row.append(h.short)

	    if vals['ip'] :
		row.append(h.ip)

	    if vals['dns'] :
		row.append(h.dns)

	    if vals['empty'] :
		row.append('')

	    if vals['ts'] :
		self.has_rep(row, h, '10114-W')

	    if vals['sf'] :
		self.has_rep(row, h, '11618-W')

	    if vals['sr'] :
		self.has_rep(row, h, '11834-W')

	    if vals['nr'] :
		self.has_rep(row, h, '10201-W')
	    if vals['sq'] :
		self.has_rep(row, h, '10443-H')
	    if vals['mr'] :
		self.has_rep(row, h, '10113-W')

	    tab.append(row)
	    
	return "\\table:t\n" + self.table_text(tab)

    def has_rep(self, row, host, id):

	for p in host.ports.values():
	    if p.reps.has_key(id):
		row.append('X')
		return

	row.append('')
      
class Module_netmap(Module):

    name="Net Map"
    param = [ ]
	#[ "check", "short", True,   "Short" ],
	#[ "check", "ip",    False,   "IP" ],


    def get_text(self, vals):

	tree = {}
	warn = ''
	ret = ''

	self.graph = {}

	for h in self.nv.get_hosts().values():

	    if not h.ports.has_key('general/udp'):
		warn += h.short + "(" + h.ip + ") has not traceroute\n"
		continue

	    p = h.ports['general/udp']
	    if not p.reps.has_key('10287-N') :
		warn += h.short + "(" + h.ip + ") has not traceroute\n"
		continue

	    r = p.reps['10287-N']

	    for path in self.make_path(p.reps['10287-N'].txt):

		self.add_path(path)

		#ret += h.ip + ":\n " + ("\n ".join(path)) + "\n"

	for  ip in self.graph.keys():
	    #ret += ip + ":\n " + ("\n ".join(graph[ip].succ.keys())) + "\n"
	    if self.graph[ip].fst :
		ret += "==========\n"
		ret += self.print_tree(ip)

	    #ret += h.short + ":\n" + r.txt + "----\n\n"

	return ret + warn

    def print_tree(self, ip, pref = '', ch = '*'):
	if pref == '' :
	    for iip in self.graph.keys():
		self.graph[iip].dirty = 0

	short = ""
	if self.nv.report.has_key(ip):
	    short  = " (" + self.nv.report[ip].short + ", " + \
		            self.nv.report[ip].dns + ")"

	ret = pref[:-1] + ch + "--- " + ip + short

	if self.graph[ip].dirty :
	    return ret + "*\n"

	self.graph[ip].dirty = 1
	ret += "\n"

	succs = self.graph[ip].succ.keys()
	for succ in succs:
	    if succ == succs[-1]:
		ret += self.print_tree(succ, pref + "   ", '`' )
	    else:
		ret += self.print_tree(succ, pref + "  |", '+')
		

	return ret
	    


    def add_path(self, path):

	self.make_comp(path[0])
	self.graph[path[0]].fst = 1

	for i in range(len(path) - 1):

	    self.make_comp(path[i+1])
	    self.graph[path[i]].succ[path[i+1]] = 1

    class Comp:
	def __init__(self):
	    self.succ =  {}
	    self.fst = 0
	    self.dirty = 0

    def make_comp(self, ip):

	if self.graph.has_key(ip) :
	    return

	self.graph[ip] = Module_netmap.Comp()


    def make_path(self, txt):

	ret = []
	parts = txt.split('\n----')

	for p in parts:

	    rows = p.split("\n");
	    ips = [x for x in rows
	              if( (len(x)>0) & (x[0:1] in string.digits) )] 
	    ret.append(ips)

	return ret


class Module_rpc(Module):

    name = "RPC/DCE"
    param = [
       [ "check" , "all",     True, "All in 1"  ],  
       [ "check" , "host",    True, "Host"  ],  
       [ "check" , "port",    True, "Port"  ],  
       [ "check" , "uuid",    False, "UUID"  ],  
       [ "check" , "ver",     True, "Version"  ],  
       [ "check" , "eproto",  True, "EP Proto"  ],  
       [ "check" , "ephost",  False, "EP Host"  ],  
       [ "check" , "epport",  False, "Port"  ],  
       [ "check" , "annot",   True, "Annot"  ],  
       ]

    re_uuid = re.compile('UUID: ([^,]*), version (\d*)')
    #re_uuid = re.compile('(U)(U)ID: ')
    re_endpoint = re.compile('Endpoint: ([^:]*):([^\[]*)\[([^\]]*)\]')
    re_anotation = re.compile('Annotation: (.*)')


    def get_text(self, vals):

	hosts = self.nv.get_hosts()

	heads2 = [
	    ('Host', 'host'),
	    ('Port', 'port'),
	    ('UUID', 'uuid'),
	    ('Verze', 'ver'),
	    ('EP Host', 'ephost'),
	    ('EP Proto', 'eproto'),
	    ('EP Port',  'epport'),
	    ('Pozn.', 'annot'),
	    ]

	head_sel = self.select_ziped(heads2, vals) 
	tab = [ head_sel ]
	heads = [ y for x,y in heads2 ] #unzip

	ret = ''

	for h in hosts.values():
	    for p in  h.ports.values():
		if p.reps.has_key('10736-N') :

		    txt = p.reps['10736-N'].txt
		    #print txt

		    uuid, ver, epproto, ephost, epport, annot = ['']*6

		    reg =  self.re_uuid.search(txt) 
		    if reg != None:
			uuid, ver = reg.groups()

		    reg =  self.re_endpoint.search(txt) 
		    if reg != None:
			epproto, ephost, epport = reg.groups()

		    reg =  self.re_anotation.search(txt)
		    if reg != None:
			annot, = reg.groups()

		    tab.append( 
			self.select(
			    [	h.short, p.name,
				uuid, ver,
				ephost, epproto, epport,
				annot
			    ], 
			    heads, 
			    vals ))

	    if not vals['all']:
		ret +=  "\n%"+ h.short + "\n\\table:t\n" + self.table_text(tab)
		tab = [ head_sel ]

	if vals['all'] :
	    ret =  "\n%"+ h.short + "\n\\table:t\n" + self.table_text(tab)

	return ret
		    

    def select(self, row, headv,  vals):
	    return [ v for v,vv in zip(row, headv) if( vals[vv] ) ]
	
    def select_ziped(self,  head,  vals):
	    return [ v for v,vv in head if( vals[vv] ) ]

class Module_runtimes(Module):

    name = "Nessus Times"
    param = []

    def get_text(self, vals):

	tab = []

	for h in self.nv.get_hosts().values():
	    for e in h.ends:

		tab.append( [
		    e.get('host_start'),
		    e.get('host_end'),
		    h.short
		    ])

	tab.sort()

	last_date = ''

	tab2 = [['Datum', 'Start', 'Konec', 'Host' ]]
	for row in tab:

	    beg_date, beg_time, end_time = ['?']*3

	    if row[1] != None:
		end_date = "%2i.%i." % ( row[1][2], row[1][1])
		end_time =  "%2i:%02i" % (row[1][3], row[1][4])

	    if row[0] != None:
		beg_date = "%2i.%i." % ( row[0][2], row[0][1])
		beg_time =  "%2i:%02i" % (row[0][3], row[0][4])
	    else:
		beg_date = end_date

	    if beg_date == last_date:
		beg_date = ''
	    else:
		last_date = beg_date

	    tab2.append([beg_date, beg_time, end_time, row[2]])
	    
	    
	return "\\table:t\n" + self.table_text(tab2)

	


def usage():
    print "usage: " + sys.argv[0] + " file.nbe"
    print "   browse file.nbe (changes to file.nerv)"

def main():

    if( len(sys.argv) != 2 ):
	usage()
    else:
	global file_name
	file_name = sys.argv[1]
	Nessus_view()
	gtk.main()

if __name__ == "__main__":
    main()
    print "\\bye"



# vim: sts=4 sw=4 indk=
